#include < amxmodx >
#include < hamsandwich >
#include < as_core >

#define PL_NAME "Army System (EA)"
#define PL_VERSION "3.2.0"
#define PL_AUTHOR "OverGame"

#define PL_KILL_EXP 1

enum _:udata { level, exp }
new data [ 33 ][ udata ], asName [ 36 ][ 64 ], asExp [ 36 ][ 64 ], g_FWD_CheckPoints, g_FWD_CheckBase, g_FWD_SaveBase, g_FWD_Result;

public plugin_init () {
	_as_ini_read ();
	register_plugin ( PL_NAME, PL_VERSION, PL_AUTHOR );
	register_cvar ( "as_version", PL_VERSION, FCVAR_SERVER | FCVAR_SPONLY );
	RegisterHam ( Ham_Killed, "player", "fwd_Ham_Killed" );
	
	g_FWD_SaveBase = CreateMultiForward ( "AS_Save_Base", ET_CONTINUE, FP_CELL );
	g_FWD_CheckBase = CreateMultiForward ( "AS_Check_Base", ET_CONTINUE, FP_CELL );
	g_FWD_CheckPoints = CreateMultiForward ( "AS_New_Level", ET_CONTINUE, FP_CELL, FP_CELL );
}

public plugin_natives () {
	register_native ( "as_get_rankname", "native_get_rankname" );

	register_native ( "as_get_user_level", "native_get_user_level", 1 );
	register_native ( "as_set_user_level", "native_set_user_level", 1 );
	
	register_native ( "as_get_user_max_exp", "native_get_user_max_exp", 1 );
	register_native ( "as_get_user_exp", "native_get_user_exp", 1 );
	register_native ( "as_set_user_exp", "native_set_user_exp", 1 );
}

public native_get_user_level ( id ) return data [ id ][ level ];
public native_set_user_level ( id, level_2 ) {
	data [ id ][ level ] = level_2;
	CHECK_points ( id );
	return level_2;
}
native as_get_rankname ( szName [], len, level );
public native_get_rankname () {
	new len = get_param ( 2 );
	new lvl = get_param ( 3 );
	set_string ( 1, asName [ lvl ], len );
	return 1;
}
public native_get_user_max_exp ( id ) return str_to_num ( asExp [ data [ id ][ level ] ] );
public native_get_user_exp ( id ) return data [ id ][ exp ];
public native_set_user_exp ( id, exp_2 ) {
	data [ id ][ exp ] = exp_2;
	CHECK_points ( id );
	return exp_2;
}

public fwd_Ham_Killed ( victim, attacker ) {
	if ( !is_user_connected ( victim ) || !is_user_connected ( attacker ) ) return HAM_IGNORED;
	if ( (victim == attacker) || victim == 0 ) return HAM_IGNORED;
	data [ attacker ][ exp ] += PL_KILL_EXP;
	CHECK_points ( attacker );
	
	return HAM_IGNORED;
}

public CHECK_points ( id ) {
	if ( data [ id ][ level ] <= 0 ) data [ id ][ level ] = 1;
	if ( data [ id ][ exp ] < 0 ) data [ id ][ exp ] = 0;

	while ( data [ id ][ exp ] >= str_to_num ( asExp [ data [ id ][ level ] ] ) ) {
		data [ id ][ level ]++;
		ExecuteForward ( g_FWD_CheckPoints, g_FWD_Result, id, data [ id ][ level ] );
	}
}

public client_putinserver ( id ) ExecuteForward ( g_FWD_CheckBase, g_FWD_Result, id );
public client_disconnect ( id ) ExecuteForward ( g_FWD_SaveBase, g_FWD_Result, id );

stock _as_ini_read () {
	new buffer [ 256 ], line, file = fopen ( "/addons/amxmodx/configs/as_core/levels.ini", "r" );
	
	while ( !feof ( file ) ) {
		fgets ( file, buffer, 255 );
		trim ( buffer );
		
		if ( buffer [ 0 ] == '"' ) {
			parse ( buffer, asName [ line ], 64, asExp [ line ], 64 );
		} else {
			continue;
		}
		line++;
	}
	fclose ( file );
}